Commits

camlspotter committed 60f3880

commited sexplib-7.0.4

Comments (0)

Files changed (50)

+repo: 3f3ede295629c1705d0d9cacc5eb2987690a5e09
+node: 4dedb3bc6b76a611fea5eaae9b1206e6d189b0ed
+branch: default
+tag: forge-release-7.0.4
+(^|/)\.bzr($|/)
+(^|/)\.hg($|/)
+(^|/)\.hgtags($|/)
+2011-09-15:  Fixes to improve package dependency resolution.
+
+2011-07-05:  Fixed a parser position bug.  Parser positions passed by the user
+             were not updated correctly.
+
+             Internal code beautification.
+
+2011-07-04:  Internal updates to sync with Jane Street.
+
+2011-01-30:  Fixed a code generation bug with toplevel entries.
+
+             Thanks to Yong Lu <lyongu@gmail.com> for the report!
+
+2010-12-27:  Added support for MoreLabels.Hashtbl and improved reporting of
+             error locations with preprocessor.
+
+2010-12-26:  Worked around a compiler bug that is expected to be fixed in
+             OCaml 3.12.1.  This workaround temporarily removes the interface
+             for module Conv (conv.mli), thus exposing the internals.
+             This should not cause any problems for end users as long as
+             they do not depend on the exported internal representations.
+             The interface will become constrained again as soon as the
+             fixed compiler is out.
+
+2010-12-22:  Major release.
+
+             Merged with Jane Street version.  This has caused an API-change
+             that requires "open Sexplib.Conv" at the top of files that use the
+             syntax extension.
+
+             Renamed functions:
+
+               * sexp_of_lazy -> sexp_of_lazy_t
+               * lazy_of_sexp -> lazy_t_of_sexp
+
+            Some standard library modules are now re-exported with predefined
+            S-expression converters in module Conv.
+
+2010-09-25:  Fixed inferred types of generated functions when dealing with arrow
+             types.
+
+2010-08-26:  Fixed a lexer bug when parsing comments.
+
+2010-05-21:  Added support for sexp_bool record field annotations.
+
+2010-05-18:  Improved performance of converting S-expressions to strings.
+
+2010-04-12:  Changed API of Of_sexp_error exception.
+
+2010-04-07:  Added of_(big)string_conv_exn functions.
+
+2010-04-01:  Merged with Jane Street version.
+
+             Major new features (various functions):
+
+               * Type-annotated parsing for better error messages
+               * Greatly improved performance of exception converters
+
+2009-12-21:  Improved saving of files.
+
+2009-10-12:  Added sexp_array record field extension.
+
+2009-09-19:  Added missing variant type cases.
+
+             Fixed handling of variance annotations.
+
+2009-09-15:  Internal cleanups.
+
+2009-07-28:  Added better support for conversion of exception types.
+
+2009-06-23:  Fixed build problem.
+
+             Thanks to Sylvain Le Gall <gildor@ocamlcore.org> for
+             the patch!
+
+2009-05-08:  Fixed build problems on Windows and OCamlMakefile issues.
+
+             Thanks to Sylvain Le Gall <gildor@ocamlcore.org> for
+             the patch!
+
+2009-04-22:  Added macro support for all types of vectors, matrices,
+             and for bigstrings.
+
+2009-04-21:  Merged with Jane Street version, no user-relevant changes.
+
+2009-03-09:  Merged with Jane Street version, no user-relevant changes.
+
+2009-03-01:  Fixed build problem on Mac OS X by updating OCamlMakefile.
+
+2009-01-20:  Automatically add S-expression pretty-printers to toplevels.
+
+2008-09-30:  Added a new feature: sexp_opaque.  It prevents the need for /
+             use of type converters for a given type in a particular
+             type context.
+
+             Removed abstract types to unify them with this new concept.
+
+2008-09-29:  Added a new feature: sexp_list.  This is similar to
+             the handling of sexp_option.  By default an empty list is
+             assumed for unspecified records using sexp_list as qualifier.
+             Such record fields bound to empty lists will also not be
+             printed anymore for better readability.
+
+2008-09-23:  Added missing Not_found-exception to standard exception
+             converters.
+
+2008-08-20:  Removed dependency on threads.  Fixed build problems.
+
+2008-08-08:  Nifty new feature: exceptions can now be converted to
+             S-expressions, too!  The "with sexp" syntax extension can be
+             used with exceptions, thus registering a conversion function.
+             A global exception conversion function can then be called
+             to convert an arbitrary exception into an S-expression,
+             which can then be printed out.  This should greatly
+             improve readability of uncaught exceptions while making
+             life extremely easy for the developer.
+
+             Renamed the ParseError exception to Parse_error to be more
+             compliant with Jane Street naming conventions.
+
+2008-07-25:  Added utilities for conversion error handling.  Minor fixes.
+
+2008-04-24:  Made Sexp-interface manifest.
+
+2008-03-20:  Fixed META-file (missing num dependency).
+
+2008-03-17:  Improved META-file.
+
+2008-03-13:  Fully allow function types in converters.  Raise runtime
+             exceptions on converting from S-expressions instead when
+             function type encountered.
+
+2008-02-11:  Fixed code generation problems with variance annotations
+             in signatures, and empty types.
+
+2007-12-17:  Added support for generating signature entries for
+             S-expression converters.  Thanks to Till Varoquaux
+             <till.varoquaux@gmail.com> for the patch!
+
+2007-11-29:  Added support for converting big_int, nat, num, and ratio.
+
+2007-11-26:  Added support for parsing from bigstrings (char bigarrays).
+
+2007-11-02:  Added syntax support for option types to use the ordinary
+             sum type syntax.  This should improve readability.
+             The old syntax will be accepted, too, if
+             Conv.read_old_option_format is set to true (this is
+             currently the default).  The old format will be used for
+             writing if Conv.write_old_option_format is true (currently
+             the default).  The old syntax is deprecated and will
+             probably not be supported by default in the near future.
+             Reading new-style option values will always succeed.
+
+2007-09-14:  Fixed bug in S-expression preprocessor concerning record
+             field names.
+
+2007-08-06:  Added support for converting functions to S-expressions.
+
+2007-07-20:  Fixed position information and improved speed of S-expression
+             parser.  Fixed S-expression macro bug concerning contained
+             polymorphic variants.
+
+2007-06-28:  Improved Sexplib code generation.
+
+2007-06-22:  Fixed escaping bug in S-expression parser.
+
+2007-06-01:  Added correct handling of recursive types + test case.
+
+2007-04-18:  Added missing conversion functions from S-expressions to
+             pairs and triples.
+
+2007-03-21:  Updated OCamlMakefile.
+
+2007-03-02:  Improved error messages when parsing illegal type definitions.
+
+2007-01-30:  Added triple conversions.
+
+2006-11-22:  Updated OCamlMakefile.
+
+2006-10-13:  Improved checking of records for extra or duplicate fields.
+
+2006-09-06:  Added support for polymorphic record fields.
+
+2006-09-05:  Added support for manifest types.
+
+2006-08-16:  Improved error messages.
+
+2006-07-28:  Added a new, hand-written S-expression parser that supports
+             partial parsing and should be approx. 10x faster than the
+             previous one.
+
+2006-06-20:  Fixed a code generation problem leading to compilation
+             errors concerning the use of type aliases within polymorphic
+             variant type definitions.
+
+             This fix also solves potential erroneous appearances of
+             backtracking exceptions in user code.
+
+2006-03-21:  Added -for-pack option to Makefile and cleaned up
+             distribution for a new public release.
+
+2006-03-13:  Sexplib now accepts capitalized booleans.
+
+2006-03-03:  Added customizable indentation levels.
+             Improved documentation.
+             Fixed API-problem concerning backward compatibility.
+
+2006-03-03:  Added customizable indentation levels.
+             Improved documentation.
+
+2006-03-01:  Added a missing flush for string conversions with a buffer.
+
+2006-02-08:  Eliminated unused variable warnings in Sexplib-generated code.
+
+2006-01-11:  Added functions for pretty-printing to buffers.  Improved
+             performance of outputting S-expressions to channels.
+
+2006-01-09:  Added functions load_sexp and load_sexps.
+
+2006-01-04:  Changed float conversion from %E to %G (more readable).
+
+2005-12-28:  Made machine representation for S-expressions more compact
+
+2005-12-15:  Fixed a problem appearing with OCaml-release 3.08.4:  CamlP4
+             obviously performs more strict checking on some constructs
+             now and crashed with an exception when generating
+             S-expression code for records containing only one field
+             ("singleton tuple problem").  This problem is fixed now.
+
+2005-11-25:  Fixed problem with type variables that could not be generalized.
+
+2005-11-23:  Added a missing case in type definitions (path alias)
+
+2005-11-17:  Major release: 2.0
+
+             Fixed a major design problem.  The user now has to pass lex
+             buffers instead of channels to input-functions.  Reason:
+             trailing characters in channels were lost due to ocamllex
+             buffering them in the non-exposed lex buffer.  This lex
+             buffer is now exposed.  The functions have been renamed
+             ("input_X" -> "scan_X") to reflect this change.
+
+2005-11-16:  Added label to conversion function "input_cnv_sexps".
+
+2005-11-11:  Fixed a bug in the pretty-printer: strings in atoms were
+             not escaped in the function "to_string_mach" (and therefore
+             also "to_string").
+
+2005-11-07:  Initial release.
+(* OASIS_START *)
+(* DO NOT EDIT (digest: 623866a2a9173f0ea5035a3d95fa48d2) *)
+This is the INSTALL file for the sexplib distribution.
+
+This package uses OASIS to generate its build system. See section OASIS for
+full information. 
+
+Dependencies
+============
+
+In order to compile this package, you will need:
+* ocaml (>= 3.12) for all, test conv, test sexp
+* findlib
+* type-conv (>= 3.0.4) for library pa_sexp_conv
+
+Installing
+==========
+
+1. Uncompress the source archive and go to the root of the package
+2. Run 'ocaml setup.ml -configure'
+3. Run 'ocaml setup.ml -build'
+4. Run 'ocaml setup.ml -install'
+
+Uninstalling
+============
+
+1. Go to the root of the package 
+2. Run 'ocaml setup.ml -uninstall'
+
+OASIS
+=====
+
+OASIS is a program that generates a setup.ml file using a simple '_oasis'
+configuration file. The generated setup only depends on the standard OCaml
+installation: no additional library is required.
+
+(* OASIS_STOP *)
+The Library is distributed under the terms of the GNU Lesser General
+Public License version 2.1 (included below).
+
+As a special exception to the GNU Lesser General Public License, you
+may link, statically or dynamically, a "work that uses the Library"
+with a publicly distributed version of the Library to produce an
+executable file containing portions of the Library, and distribute that
+executable file under terms of your choice, without any of the additional
+requirements listed in clause 6 of the GNU Lesser General Public License.
+By "a publicly distributed version of the Library", we mean either the
+unmodified Library as distributed by the authors, or a modified version
+of the Library that is distributed under the conditions defined in clause
+3 of the GNU Lesser General Public License.  This exception does not
+however invalidate any other reasons why the executable file might be
+covered by the GNU Lesser General Public License.
+
+---------------------------------------------------------------------------
+
+		  GNU LESSER GENERAL PUBLIC LICENSE
+		       Version 2.1, February 1999
+
+ Copyright (C) 1991, 1999 Free Software Foundation, Inc.
+     59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+[This is the first released version of the Lesser GPL.  It also counts
+ as the successor of the GNU Library Public License, version 2, hence
+ the version number 2.1.]
+
+			    Preamble
+
+  The licenses for most software are designed to take away your
+freedom to share and change it.  By contrast, the GNU General Public
+Licenses are intended to guarantee your freedom to share and change
+free software--to make sure the software is free for all its users.
+
+  This license, the Lesser General Public License, applies to some
+specially designated software packages--typically libraries--of the
+Free Software Foundation and other authors who decide to use it.  You
+can use it too, but we suggest you first think carefully about whether
+this license or the ordinary General Public License is the better
+strategy to use in any particular case, based on the explanations below.
+
+  When we speak of free software, we are referring to freedom of use,
+not price.  Our General Public Licenses are designed to make sure that
+you have the freedom to distribute copies of free software (and charge
+for this service if you wish); that you receive source code or can get
+it if you want it; that you can change the software and use pieces of
+it in new free programs; and that you are informed that you can do
+these things.
+
+  To protect your rights, we need to make restrictions that forbid
+distributors to deny you these rights or to ask you to surrender these
+rights.  These restrictions translate to certain responsibilities for
+you if you distribute copies of the library or if you modify it.
+
+  For example, if you distribute copies of the library, whether gratis
+or for a fee, you must give the recipients all the rights that we gave
+you.  You must make sure that they, too, receive or can get the source
+code.  If you link other code with the library, you must provide
+complete object files to the recipients, so that they can relink them
+with the library after making changes to the library and recompiling
+it.  And you must show them these terms so they know their rights.
+
+  We protect your rights with a two-step method: (1) we copyright the
+library, and (2) we offer you this license, which gives you legal
+permission to copy, distribute and/or modify the library.
+
+  To protect each distributor, we want to make it very clear that
+there is no warranty for the free library.  Also, if the library is
+modified by someone else and passed on, the recipients should know
+that what they have is not the original version, so that the original
+author's reputation will not be affected by problems that might be
+introduced by others.
+
+  Finally, software patents pose a constant threat to the existence of
+any free program.  We wish to make sure that a company cannot
+effectively restrict the users of a free program by obtaining a
+restrictive license from a patent holder.  Therefore, we insist that
+any patent license obtained for a version of the library must be
+consistent with the full freedom of use specified in this license.
+
+  Most GNU software, including some libraries, is covered by the
+ordinary GNU General Public License.  This license, the GNU Lesser
+General Public License, applies to certain designated libraries, and
+is quite different from the ordinary General Public License.  We use
+this license for certain libraries in order to permit linking those
+libraries into non-free programs.
+
+  When a program is linked with a library, whether statically or using
+a shared library, the combination of the two is legally speaking a
+combined work, a derivative of the original library.  The ordinary
+General Public License therefore permits such linking only if the
+entire combination fits its criteria of freedom.  The Lesser General
+Public License permits more lax criteria for linking other code with
+the library.
+
+  We call this license the "Lesser" General Public License because it
+does Less to protect the user's freedom than the ordinary General
+Public License.  It also provides other free software developers Less
+of an advantage over competing non-free programs.  These disadvantages
+are the reason we use the ordinary General Public License for many
+libraries.  However, the Lesser license provides advantages in certain
+special circumstances.
+
+  For example, on rare occasions, there may be a special need to
+encourage the widest possible use of a certain library, so that it becomes
+a de-facto standard.  To achieve this, non-free programs must be
+allowed to use the library.  A more frequent case is that a free
+library does the same job as widely used non-free libraries.  In this
+case, there is little to gain by limiting the free library to free
+software only, so we use the Lesser General Public License.
+
+  In other cases, permission to use a particular library in non-free
+programs enables a greater number of people to use a large body of
+free software.  For example, permission to use the GNU C Library in
+non-free programs enables many more people to use the whole GNU
+operating system, as well as its variant, the GNU/Linux operating
+system.
+
+  Although the Lesser General Public License is Less protective of the
+users' freedom, it does ensure that the user of a program that is
+linked with the Library has the freedom and the wherewithal to run
+that program using a modified version of the Library.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.  Pay close attention to the difference between a
+"work based on the library" and a "work that uses the library".  The
+former contains code derived from the library, whereas the latter must
+be combined with the library in order to run.
+
+		  GNU LESSER GENERAL PUBLIC LICENSE
+   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+  0. This License Agreement applies to any software library or other
+program which contains a notice placed by the copyright holder or
+other authorized party saying it may be distributed under the terms of
+this Lesser General Public License (also called "this License").
+Each licensee is addressed as "you".
+
+  A "library" means a collection of software functions and/or data
+prepared so as to be conveniently linked with application programs
+(which use some of those functions and data) to form executables.
+
+  The "Library", below, refers to any such software library or work
+which has been distributed under these terms.  A "work based on the
+Library" means either the Library or any derivative work under
+copyright law: that is to say, a work containing the Library or a
+portion of it, either verbatim or with modifications and/or translated
+straightforwardly into another language.  (Hereinafter, translation is
+included without limitation in the term "modification".)
+
+  "Source code" for a work means the preferred form of the work for
+making modifications to it.  For a library, complete source code means
+all the source code for all modules it contains, plus any associated
+interface definition files, plus the scripts used to control compilation
+and installation of the library.
+
+  Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope.  The act of
+running a program using the Library is not restricted, and output from
+such a program is covered only if its contents constitute a work based
+on the Library (independent of the use of the Library in a tool for
+writing it).  Whether that is true depends on what the Library does
+and what the program that uses the Library does.
+
+  1. You may copy and distribute verbatim copies of the Library's
+complete source code as you receive it, in any medium, provided that
+you conspicuously and appropriately publish on each copy an
+appropriate copyright notice and disclaimer of warranty; keep intact
+all the notices that refer to this License and to the absence of any
+warranty; and distribute a copy of this License along with the
+Library.
+
+  You may charge a fee for the physical act of transferring a copy,
+and you may at your option offer warranty protection in exchange for a
+fee.
+
+  2. You may modify your copy or copies of the Library or any portion
+of it, thus forming a work based on the Library, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+    a) The modified work must itself be a software library.
+
+    b) You must cause the files modified to carry prominent notices
+    stating that you changed the files and the date of any change.
+
+    c) You must cause the whole of the work to be licensed at no
+    charge to all third parties under the terms of this License.
+
+    d) If a facility in the modified Library refers to a function or a
+    table of data to be supplied by an application program that uses
+    the facility, other than as an argument passed when the facility
+    is invoked, then you must make a good faith effort to ensure that,
+    in the event an application does not supply such function or
+    table, the facility still operates, and performs whatever part of
+    its purpose remains meaningful.
+
+    (For example, a function in a library to compute square roots has
+    a purpose that is entirely well-defined independent of the
+    application.  Therefore, Subsection 2d requires that any
+    application-supplied function or table used by this function must
+    be optional: if the application does not supply it, the square
+    root function must still compute square roots.)
+
+These requirements apply to the modified work as a whole.  If
+identifiable sections of that work are not derived from the Library,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works.  But when you
+distribute the same sections as part of a whole which is a work based
+on the Library, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote
+it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Library.
+
+In addition, mere aggregation of another work not based on the Library
+with the Library (or with a work based on the Library) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+  3. You may opt to apply the terms of the ordinary GNU General Public
+License instead of this License to a given copy of the Library.  To do
+this, you must alter all the notices that refer to this License, so
+that they refer to the ordinary GNU General Public License, version 2,
+instead of to this License.  (If a newer version than version 2 of the
+ordinary GNU General Public License has appeared, then you can specify
+that version instead if you wish.)  Do not make any other change in
+these notices.
+
+  Once this change is made in a given copy, it is irreversible for
+that copy, so the ordinary GNU General Public License applies to all
+subsequent copies and derivative works made from that copy.
+
+  This option is useful when you wish to copy part of the code of
+the Library into a program that is not a library.
+
+  4. You may copy and distribute the Library (or a portion or
+derivative of it, under Section 2) in object code or executable form
+under the terms of Sections 1 and 2 above provided that you accompany
+it with the complete corresponding machine-readable source code, which
+must be distributed under the terms of Sections 1 and 2 above on a
+medium customarily used for software interchange.
+
+  If distribution of object code is made by offering access to copy
+from a designated place, then offering equivalent access to copy the
+source code from the same place satisfies the requirement to
+distribute the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+  5. A program that contains no derivative of any portion of the
+Library, but is designed to work with the Library by being compiled or
+linked with it, is called a "work that uses the Library".  Such a
+work, in isolation, is not a derivative work of the Library, and
+therefore falls outside the scope of this License.
+
+  However, linking a "work that uses the Library" with the Library
+creates an executable that is a derivative of the Library (because it
+contains portions of the Library), rather than a "work that uses the
+library".  The executable is therefore covered by this License.
+Section 6 states terms for distribution of such executables.
+
+  When a "work that uses the Library" uses material from a header file
+that is part of the Library, the object code for the work may be a
+derivative work of the Library even though the source code is not.
+Whether this is true is especially significant if the work can be
+linked without the Library, or if the work is itself a library.  The
+threshold for this to be true is not precisely defined by law.
+
+  If such an object file uses only numerical parameters, data
+structure layouts and accessors, and small macros and small inline
+functions (ten lines or less in length), then the use of the object
+file is unrestricted, regardless of whether it is legally a derivative
+work.  (Executables containing this object code plus portions of the
+Library will still fall under Section 6.)
+
+  Otherwise, if the work is a derivative of the Library, you may
+distribute the object code for the work under the terms of Section 6.
+Any executables containing that work also fall under Section 6,
+whether or not they are linked directly with the Library itself.
+
+  6. As an exception to the Sections above, you may also combine or
+link a "work that uses the Library" with the Library to produce a
+work containing portions of the Library, and distribute that work
+under terms of your choice, provided that the terms permit
+modification of the work for the customer's own use and reverse
+engineering for debugging such modifications.
+
+  You must give prominent notice with each copy of the work that the
+Library is used in it and that the Library and its use are covered by
+this License.  You must supply a copy of this License.  If the work
+during execution displays copyright notices, you must include the
+copyright notice for the Library among them, as well as a reference
+directing the user to the copy of this License.  Also, you must do one
+of these things:
+
+    a) Accompany the work with the complete corresponding
+    machine-readable source code for the Library including whatever
+    changes were used in the work (which must be distributed under
+    Sections 1 and 2 above); and, if the work is an executable linked
+    with the Library, with the complete machine-readable "work that
+    uses the Library", as object code and/or source code, so that the
+    user can modify the Library and then relink to produce a modified
+    executable containing the modified Library.  (It is understood
+    that the user who changes the contents of definitions files in the
+    Library will not necessarily be able to recompile the application
+    to use the modified definitions.)
+
+    b) Use a suitable shared library mechanism for linking with the
+    Library.  A suitable mechanism is one that (1) uses at run time a
+    copy of the library already present on the user's computer system,
+    rather than copying library functions into the executable, and (2)
+    will operate properly with a modified version of the library, if
+    the user installs one, as long as the modified version is
+    interface-compatible with the version that the work was made with.
+
+    c) Accompany the work with a written offer, valid for at
+    least three years, to give the same user the materials
+    specified in Subsection 6a, above, for a charge no more
+    than the cost of performing this distribution.
+
+    d) If distribution of the work is made by offering access to copy
+    from a designated place, offer equivalent access to copy the above
+    specified materials from the same place.
+
+    e) Verify that the user has already received a copy of these
+    materials or that you have already sent this user a copy.
+
+  For an executable, the required form of the "work that uses the
+Library" must include any data and utility programs needed for
+reproducing the executable from it.  However, as a special exception,
+the materials to be distributed need not include anything that is
+normally distributed (in either source or binary form) with the major
+components (compiler, kernel, and so on) of the operating system on
+which the executable runs, unless that component itself accompanies
+the executable.
+
+  It may happen that this requirement contradicts the license
+restrictions of other proprietary libraries that do not normally
+accompany the operating system.  Such a contradiction means you cannot
+use both them and the Library together in an executable that you
+distribute.
+
+  7. You may place library facilities that are a work based on the
+Library side-by-side in a single library together with other library
+facilities not covered by this License, and distribute such a combined
+library, provided that the separate distribution of the work based on
+the Library and of the other library facilities is otherwise
+permitted, and provided that you do these two things:
+
+    a) Accompany the combined library with a copy of the same work
+    based on the Library, uncombined with any other library
+    facilities.  This must be distributed under the terms of the
+    Sections above.
+
+    b) Give prominent notice with the combined library of the fact
+    that part of it is a work based on the Library, and explaining
+    where to find the accompanying uncombined form of the same work.
+
+  8. You may not copy, modify, sublicense, link with, or distribute
+the Library except as expressly provided under this License.  Any
+attempt otherwise to copy, modify, sublicense, link with, or
+distribute the Library is void, and will automatically terminate your
+rights under this License.  However, parties who have received copies,
+or rights, from you under this License will not have their licenses
+terminated so long as such parties remain in full compliance.
+
+  9. You are not required to accept this License, since you have not
+signed it.  However, nothing else grants you permission to modify or
+distribute the Library or its derivative works.  These actions are
+prohibited by law if you do not accept this License.  Therefore, by
+modifying or distributing the Library (or any work based on the
+Library), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Library or works based on it.
+
+  10. Each time you redistribute the Library (or any work based on the
+Library), the recipient automatically receives a license from the
+original licensor to copy, distribute, link with or modify the Library
+subject to these terms and conditions.  You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties with
+this License.
+
+  11. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Library at all.  For example, if a patent
+license would not permit royalty-free redistribution of the Library by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Library.
+
+If any portion of this section is held invalid or unenforceable under any
+particular circumstance, the balance of the section is intended to apply,
+and the section as a whole is intended to apply in other circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system which is
+implemented by public license practices.  Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+  12. If the distribution and/or use of the Library is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Library under this License may add
+an explicit geographical distribution limitation excluding those countries,
+so that distribution is permitted only in or among countries not thus
+excluded.  In such case, this License incorporates the limitation as if
+written in the body of this License.
+
+  13. The Free Software Foundation may publish revised and/or new
+versions of the Lesser General Public License from time to time.
+Such new versions will be similar in spirit to the present version,
+but may differ in detail to address new problems or concerns.
+
+Each version is given a distinguishing version number.  If the Library
+specifies a version number of this License which applies to it and
+"any later version", you have the option of following the terms and
+conditions either of that version or of any later version published by
+the Free Software Foundation.  If the Library does not specify a
+license version number, you may choose any version ever published by
+the Free Software Foundation.
+
+  14. If you wish to incorporate parts of the Library into other free
+programs whose distribution conditions are incompatible with these,
+write to the author to ask for permission.  For software which is
+copyrighted by the Free Software Foundation, write to the Free
+Software Foundation; we sometimes make exceptions for this.  Our
+decision will be guided by the two goals of preserving the free status
+of all derivatives of our free software and of promoting the sharing
+and reuse of software generally.
+
+			    NO WARRANTY
+
+  15. BECAUSE THE LIBRARY IS LICENSED FREE OF CHARGE, THERE IS NO
+WARRANTY FOR THE LIBRARY, TO THE EXTENT PERMITTED BY APPLICABLE LAW.
+EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR
+OTHER PARTIES PROVIDE THE LIBRARY "AS IS" WITHOUT WARRANTY OF ANY
+KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE
+IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE
+LIBRARY IS WITH YOU.  SHOULD THE LIBRARY PROVE DEFECTIVE, YOU ASSUME
+THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
+
+  16. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
+WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY
+AND/OR REDISTRIBUTE THE LIBRARY AS PERMITTED ABOVE, BE LIABLE TO YOU
+FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR
+CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE
+LIBRARY (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING
+RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A
+FAILURE OF THE LIBRARY TO OPERATE WITH ANY OTHER SOFTWARE), EVEN IF
+SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
+DAMAGES.
+
+		     END OF TERMS AND CONDITIONS
+
+           How to Apply These Terms to Your New Libraries
+
+  If you develop a new library, and you want it to be of the greatest
+possible use to the public, we recommend making it free software that
+everyone can redistribute and change.  You can do so by permitting
+redistribution under these terms (or, alternatively, under the terms of the
+ordinary General Public License).
+
+  To apply these terms, attach the following notices to the library.  It is
+safest to attach them to the start of each source file to most effectively
+convey the exclusion of warranty; and each file should have at least the
+"copyright" line and a pointer to where the full notice is found.
+
+    <one line to give the library's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This library is free software; you can redistribute it and/or
+    modify it under the terms of the GNU Lesser General Public
+    License as published by the Free Software Foundation; either
+    version 2.1 of the License, or (at your option) any later version.
+
+    This library is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+    Lesser General Public License for more details.
+
+    You should have received a copy of the GNU Lesser General Public
+    License along with this library; if not, write to the Free Software
+    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+Also add information on how to contact you by electronic and paper mail.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the library, if
+necessary.  Here is a sample; alter the names:
+
+  Yoyodyne, Inc., hereby disclaims all copyright interest in the
+  library `Frob' (a library for tweaking knobs) written by James Random Hacker.
+
+  <signature of Ty Coon>, 1 April 1990
+  Ty Coon, President of Vice
+
+That's all there is to it!
+---------------------------------------------------------------------------
+Copyright (c) 2004 Martin Sandin
+All rights reserved.
+
+Redistribution and use in source and binary forms, with or without
+modification, are permitted provided that the following conditions
+are met:
+1. Redistributions of source code must retain the above copyright
+   notice, this list of conditions and the following disclaimer.
+2. Redistributions in binary form must reproduce the above copyright
+   notice, this list of conditions and the following disclaimer in the
+   documentation and/or other materials provided with the distribution.
+3. The name of the author may not be used to endorse or promote products
+   derived from this software without specific prior written permission.
+
+THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+---------------------------------------------------------------------------
+# OASIS_START
+# DO NOT EDIT (digest: bc1e05bfc8b39b664f29dae8dbd3ebbb)
+
+SETUP = ocaml setup.ml
+
+build: setup.data
+	$(SETUP) -build $(BUILDFLAGS)
+
+doc: setup.data build
+	$(SETUP) -doc $(DOCFLAGS)
+
+test: setup.data build
+	$(SETUP) -test $(TESTFLAGS)
+
+all: 
+	$(SETUP) -all $(ALLFLAGS)
+
+install: setup.data
+	$(SETUP) -install $(INSTALLFLAGS)
+
+uninstall: setup.data
+	$(SETUP) -uninstall $(UNINSTALLFLAGS)
+
+reinstall: setup.data
+	$(SETUP) -reinstall $(REINSTALLFLAGS)
+
+clean: 
+	$(SETUP) -clean $(CLEANFLAGS)
+
+distclean: 
+	$(SETUP) -distclean $(DISTCLEANFLAGS)
+
+setup.data:
+	$(SETUP) -configure $(CONFIGUREFLAGS)
+
+.PHONY: build doc test all install uninstall reinstall clean distclean configure
+
+# OASIS_STOP
+OMyOasis(sexplib, $(Installed type-conv))
+

OMakefile.omc

Binary file added.
+      
+                                        
+                          README: library "Sexplib"
+                          *************************
+             Copyright   (C)   2011  Jane Street Holding, LLC (1)
+            =====================================================
+                             Author: Markus Mottl 
+                            ======================
+                             New York, 2010-03-31
+                             ====================
+  
+
+1  Directory contents
+*=*=*=*=*=*=*=*=*=*=*
+
+   
+                                        
+   ------------------------------------------------------------------------
+   |     CHANGES       |              History of code changes             |
+   ------------------------------------------------------------------------
+   |    COPYRIGHT      |                 Notes on copyright               |
+   ------------------------------------------------------------------------
+   |     INSTALL       |            Short notes on compiling and          |
+   |                   |               installing the library             |
+   ------------------------------------------------------------------------
+   |     LICENSE       |        "GNU LESSER GENERAL PUBLIC LICENSE"       |
+   ------------------------------------------------------------------------
+   |  LICENSE.Tywith   |  License of Tywith, from which Sexplib is derived|
+   ------------------------------------------------------------------------
+   |     Makefile      |                    Top Makefile                  |
+   ------------------------------------------------------------------------
+   |  OCamlMakefile    |        Generic Makefile for OCaml-projects       |
+   ------------------------------------------------------------------------
+   |    OMakefile      |                  Ignore this file                |
+   ------------------------------------------------------------------------
+   |    README.txt     |                     This file                    |
+   ------------------------------------------------------------------------
+   |       lib/        |     OCaml-library for S-expression conversions   |
+   ------------------------------------------------------------------------
+   |    lib_test/      |     Test applications for the Sexplib-library    |
+   ------------------------------------------------------------------------
+                                        
+  
+  
+
+2  What is "Sexplib"?
+*=*=*=*=*=*=*=*=*=*=*
+
+  
+  This library contains functionality for parsing and pretty-printing
+S-expressions. In addition to that it contains a preprocessing module for
+Camlp4, which can be used to automatically generate code from type definitions
+for efficiently converting OCaml-values to S-expressions and vice versa. In
+combination with the parsing and pretty-printing functionality this frees
+users from having to write their own I/O-routines for datastructures they
+define. Possible errors during automatic conversions from S-expressions to
+OCaml-values are reported in human-readable ways with exact location
+information. Another module in this library allows you to extract and replace
+sub-expressions in S-expressions.
+  
+
+3  How can you use it?
+*=*=*=*=*=*=*=*=*=*=*=
+
+  
+  Make sure you have installed the 'type-conv' package on your system, too. It
+should be obtainable at the same site as 'sexplib'.
+  
+  The API (.mli-files) in the 'sexplib' library directory is fully documented.
+Module 'Sexp' contains all I/O-functions for S-expressions, module 'Conv'
+helper functions for converting OCaml-values of standard types to
+S-expressions. Module 'Path' supports sub-expression extraction and
+substitution.
+  
+  Module 'pa_sexp_conv.ml' contains the extensions for the
+Camlp4-preprocessor. It adds the new construct 'with sexp' (and 'with sexp_of'
+and 'with of_sexp', which are implied by the first). When using this construct
+right after a type definition, function definitions will be generated
+automatically, which perform S-expression conversions.
+  
+  E.g. given the following type definition:
+<<  type t = A | B
+    with sexp
+>>
+  
+  The above will generate the functions 'sexp_of_t' and 't_of_sexp'. The
+preprocessor also supports automatic addition of conversion functions to
+signatures. Just add 'with sexp' to the type in a signature, and the
+appropriate function signatures will be generated.
+  
+  See the file 'lib_test/conv_test.ml' for example usage. It also demonstrates
+how to extract and substitute sub-expressions.
+  
+
+3.1  Compiling and linking
+==========================
+  
+  To compile a file you will have to add a preprocessing flag to the compiler
+invocation, e.g. for foo.ml:
+<<  ocamlc -pp "camlp4o -I {path to type-conv} \
+      -I {path to sexplib} pa_type_conv.cmo pa_sexp_conv.cmo" \
+      -I {path to sexplib} foo.ml
+>>
+  
+  If you are using OCamlMakefile, just put the following line at the top of
+the file, assuming you have installed both 'type-conv' and 'sexplib' with
+ocamlfind. The comment must start at the beginning of the line, and you must
+not break lines (here broken for readability only):
+<<  (*pp camlp4o -I `ocamlfind query type-conv` \
+      -I `ocamlfind query sexplib` \
+      pa_type_conv.cmo pa_sexp_conv.cmo *)
+>>
+  
+  Don't forget to place the macro 'TYPE_CONV_PATH', which takes a string
+argument, at the top of the file to be preprocessed (see example
+'conv_test.ml'). It is supposed to set the module path to the given module
+file. This is necessary, because modules may get packed at a later stage, and
+error messages generated by Sexplib will refer to this location to help
+pinpointing the associated type.
+  
+  In the linking stage you will only have to link with 'sexplib'. E.g. when
+using OCamlMakefile just add it to the 'PACKS'-variable.
+  
+
+4  Syntax Specification of S-expressions
+*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=
+
+  
+  
+
+4.1  Lexical conventions of S-expression
+========================================
+  
+  Whitespace, which consists of space, newline, carriage return, horizontal
+tab and form feed, is ignored unless within an OCaml-string, where it is
+treated according to OCaml-conventions. The semicolon introduces comments.
+Comments are ignored, and range up to the next newline character. The left
+parenthesis opens a new list, the right parenthesis closes it again. Lists can
+be empty. The double quote denotes the beginning and end of a string following
+the lexical conventions of OCaml (see OCaml-manual for details). All
+characters other than double quotes, left- and right parentheses, and
+whitespace are considered part of a contiguous string.
+  
+
+4.2  Grammar of S-expressions
+=============================
+  
+  S-expressions are either strings (= atoms) or lists. The lists can
+recursively contain further S-expressions or be empty, and must be balanced,
+i.e. parentheses must match.
+  
+
+4.3  Examples
+=============
+  
+<<  this_is_an_atom_123'&^%!  ; this is a comment
+    "another atom in an OCaml-string \"string in a string\" \123"
+  
+    ; empty list follows below
+    ()
+  
+    ; a more complex example
+    (
+      (
+        list in a list  ; comment within a list
+        (list in a list in a list)
+        42 is the answer to all questions
+      )
+    )
+>>
+  
+  
+
+4.4  Conversion of basic OCaml-values
+=====================================
+  
+  Basic OCaml-values like the unit-value, integers (in all representations),
+floats, strings, and booleans are represented in S-exp syntax in the same way
+as in OCaml. Strings may also appear without quotes if this does not clash
+with the lexical conventions for S-expressions.
+  
+
+4.5  Conversion of OCaml-tuples
+===============================
+  
+  OCaml-tuples are simple lists of values in the same order as in the tuple.
+E.g.:
+<<  (3.14, "foo", "bar bla", 27) <===> (3.14 foo "bar bla" 27)
+>>
+  
+  
+
+4.6  Conversion of OCaml-records
+================================
+  
+  OCaml-records are represented as lists of pairs in S-expression syntax. Each
+pair consists of the name of the record field (first element), and its value
+(second element). E.g.:
+<<  {
+      foo = 3;
+      bar = "some string";
+    }
+  
+    <===>
+  
+    (
+      (foo 3)
+      (bar "some string")
+    )
+>>
+  
+  Type specifications of records allow the use of a special type 'sexp_option'
+which indicates that a record field should be optional. E.g.:
+<<  type t =
+      {
+        x : int option;
+        y : int sexp_option;
+      }
+>>
+  
+  The type 'sexp_option' is equivalent to ordinary options, but is treated
+specially by the code generator. The above would lead to the following
+equivalences of values and S-expressions:
+<<  {
+      x = Some 1;
+      y = Some 2;
+    }
+  
+    <===>
+  
+    (
+      (x (some 1))
+      (y 2)
+    )
+>>
+  
+  And:
+<<  {
+      x = None;
+      y = None;
+    }
+  
+    <===>
+  
+    (
+      (x none)
+    )
+>>
+  
+  Note how 'sexp_option' allows you to leave away record fields that should
+default to 'None'. It is also unnecessary (and actually wrong) now to write
+down such a value as an option, i.e. the 'some'-tag must be dropped if the
+field should be defined.
+  
+  The types 'sexp_list', 'sexp_array', and 'sexp_bool' can be used in ways
+similar to the type 'sexp_option'. They assume the empty list, empty array,
+and false value respectively as default values.
+  
+
+4.7  Conversion of sum types
+============================
+  
+  Constant constructors in sum types are represented as strings. Constructors
+with arguments are represented as lists, the first element being the
+constructor name, the rest being its arguments. Constructors may also be
+started in lowercase in S-expressions, but will always be converted to
+uppercase when converting from OCaml-values.
+  
+  For example:
+<<  type t = A | B of int * float * t with sexp
+  
+    B (42, 3.14, B (-1, 2.72, A)) <===> (B 42 3.14 (B -1 2.72 A))
+>>
+  
+  The above example also demonstrates recursion in datastructures. 
+  
+
+4.8  Conversion of variant types
+================================
+  
+  The conversion of polymorphic variants is almost the same as with sum types.
+The notable difference is that variant constructors must always start with an
+either lower- or uppercase character, matching the way it was specified in the
+type definition. This is because OCaml also distinguishes between upper- and
+lowercase variant constructors. Note that type specifications containing
+unions of variant types are also supported by the S-expression converter.
+  
+
+4.9  Conversion of OCaml-lists and arrays
+=========================================
+  
+  OCaml-lists and arrays are straightforwardly represented as S-expression
+lists.
+  
+
+4.10  Conversion of option types
+================================
+  
+  The option type is converted like ordinary polymorphic sum types, i.e.:
+<<  None        <===>  none
+    Some value  <===>  (some value)
+>>
+  
+  There is a deprecated version of the syntax in which values of option type
+are represented as lists in S-expressions:
+<<  None        <===>  ()
+    Some value  <===>  (value)
+>>
+  
+  Reading of the old-style S-expression syntax for option values is only
+supported if the reference 'Conv.read_old_option_format' is set to 'true'
+(currently the default, which may change soon). A conversion exception is
+raised otherwise. The old format will be written only if
+'Conv.write_old_option_format' is true (also currently the default). Reading
+of the new format is always supported.
+  
+
+4.11  Conversion of polymorphic values
+======================================
+  
+  There is nothing special about polymorphic values as long as there are
+conversion functions for the type parameters. E.g.:
+<<  type 'a t = A | B of 'a with sexp
+    type foo = int t with sexp
+>>
+  
+  In the above case the conversion functions will behave as if 'foo' had been
+defined as a monomorphic version of 't' with ''a' replaced by 'int' on the
+right hand side.
+  
+  If a datastructure is indeed polymorphic, and you want to convert it, you
+will have to supply the conversion functions for the type parameters at
+runtime. E.g. in the above example, if you wanted to convert a value of type
+''a t', you would have to write something like this:
+<<  sexp_of_t sexp_of_a v
+>>
+  
+  where 'sexp_of_a', which may also be named differently in this particular
+case, is a function that converts values of type ''a' to an S-expression.
+Types with more than one parameter require passing conversion functions for
+those parameters in the order of their appearance on the left hand side of the
+type definition.
+  
+
+4.12  Conversion of abstract datatypes
+======================================
+  
+  Of course, if you want to convert an abstract datatype to an S-expression,
+you will have to roll your own conversion function, which should produce
+values of type 'Sexp.t' directly. If, however, you want to make use of your
+abstract type within definitions of other types, make sure that you call your
+conversion function appropriately: it should be in the same scope as the
+typename, and must be named 'sexp_of_{typename}'.
+  
+
+4.13  Conversion of hashtables
+==============================
+  
+  Hashtables, which are abstract values in OCaml, are represented as
+association lists, i.e. lists of key-value pairs, e.g.:
+<<  ((foo 42) (bar 3))
+>>
+  
+  Reading in the above S-expression as hashtable mapping strings to integers
+('(string, int) Hashtbl.t') will map '"foo"' to 42 and '"bar"' to 3.
+  
+  Note that the order of elements in the list may matter, because duplicates
+are kept: bindings will be inserted into the hashtable in order of appearence.
+Therefore, the last binding of a key will be the "visible" one, the others are
+"hidden". See the OCaml-documentation on hashtables for details.
+  
+  Note, too, that polymorphic equality may not hold between conversions. You
+will have to use a function implementing logical equality for that purpose.
+  
+
+4.14  Conversion of opaque values
+=================================
+  
+  Opaque values are ones for which we do not want to perform conversions. This
+may be, because we do not have S-expression converters for them, or because we
+do not want to apply them in a particular type context, e.g. if the resulting
+S-expression should be printed out but without superfluous information. To
+prevent the preprocessor from generating calls to converters, simply apply the
+qualifier 'sexp_opaque' as if it were a type constructor, e.g.:
+<<  type foo = int * stuff sexp_opaque with sexp
+>>
+  
+  Thus, there is no need to specify converters for type 'stuff', and if there
+are any, they will not be used in this particular context. Needless to say, it
+is not possible to convert such an S-expression back to the original value.
+Here is an example conversion:
+<<  (42, some_stuff) ===>  (42, <opaque>)
+>>
+  
+  
+
+4.15  Conversion of exceptions
+==============================
+  
+  S-expression converters for exceptions can be automatically registered using
+the 'with sexp' macro, e.g.:
+<<  module M = struct
+      exception Foo of int with sexp
+    end
+>>
+  
+  Such exceptions will be translated in a similar way as sum types, but their
+constructor will be prefixed with the fully qualified module path (here:
+'M.Foo') so as to be able to discriminate between them without problems.
+   The user can then easily convert an exception matching the above one to an
+S-expression using 'Sexplib.Conv.sexp_of_exn'. User-defined conversion
+functions can be registered, too, by calling 'Sexplib.Conv.add_exn_converter'.
+This should make it very convenient for users to catch arbitrary exceptions
+escaping their program and pretty-printing them, including all arguments, as
+S-expressions. The library already contains mappings for all known exceptions
+that can escape functions in the OCaml standard library.
+  
+
+5  I/O and type conversions
+*=*=*=*=*=*=*=*=*=*=*=*=*=*
+
+  
+  There are multiple ways of performing I/O with S-expressions. If exact error
+locations are required when type conversions fail, S-expressions need to be
+parsed with location annotations. In most cases users may want to use
+functions like e.g. 'load_sexp_conv' or 'load_sexp_conv_exn', which load
+S-expressions from files and convert them. Only when conversions fail, the
+file will be reparsed with annotations, which is slower, and type errors will
+be reported accurately with file, line number, column, and file position.
+  
+
+6  Contact information
+*=*=*=*=*=*=*=*=*=*=*=
+
+  
+  In the case of bugs, feature requests and similar, you can contact us here:
+     opensource@janestreet.com
+   Up-to-date information concerning this library should be available here:
+     http://www.janestreet.com/ocaml
+   Enjoy!!
+   
+-----------------------------------------------------------------------------
+  
+   This document was translated from LaTeX by HeVeA (2).
+--------------------------------------
+  
+  
+ (1) http://www.janestreet.com
+ 
+ (2) http://hevea.inria.fr/index.html
+OASISFormat:  0.2
+OCamlVersion: >= 3.12
+Name:         sexplib
+Version:      7.0.4
+Synopsis:     automated S-expression conversion
+Authors:      Markus Mottl,
+              Martin Sandin
+Copyrights:   (C) 2005-2011 Jane Street Capital LLC
+License:      LGPL-2.1 with OCaml linking exception
+LicenseFile:  LICENSE
+Plugins:      StdFiles (0.2),
+              DevFiles (0.2),
+              META (0.2)
+BuildTools:   ocamlbuild
+XStdFilesAUTHORS: false
+XStdFilesINSTALLFilename: INSTALL
+XStdFilesREADME: false
+
+Library sexplib
+  Path:               lib
+  FindlibName:        sexplib
+  Pack:               true
+  Modules:            Type,
+                      Parser,
+                      Lexer,
+                      Pre_sexp,
+                      Sexp_intf,
+                      Sexp,
+                      Path,
+                      Conv,
+                      Conv_error,
+                      Exn_magic,
+                      Std
+  BuildDepends:       unix,bigarray,num
+  XMETARequires:      unix,bigarray,num
+
+Library pa_sexp_conv
+  Path:               syntax
+  FindlibName:        syntax
+  FindlibParent:      sexplib
+  Modules:            Pa_sexp_conv
+  BuildDepends:       camlp4.quotations,camlp4.extend,type-conv (>= 3.0.4)
+  CompiledObject:     byte
+  XMETAType:          syntax
+  XMETARequires:      type-conv,sexplib
+  XMETADescription:   Syntax extension for Sexplib
+
+Library sexplib_top
+  Path:               top
+  FindlibName:        top
+  FindlibParent:      sexplib
+  Modules:            Install_printers
+  XMETARequires:      sexplib
+  XMETADescription:   Toplevel printers for S-expressions
+
+Flag tests
+  Description:        Build and run tests
+  Default:            true
+
+Executable sexp_test
+  Path:               lib_test
+  MainIs:             sexp_test.ml
+  Build$:             flag(tests)
+  Install:            false
+  BuildDepends:       sexplib
+
+Executable conv_test
+  Path:               lib_test
+  MainIs:             conv_test.ml
+  Build$:             flag(tests)
+  Install:            false
+  BuildDepends:       sexplib, sexplib.syntax
+
+Test sexp
+  Run$:               flag(tests)
+  Command:            $sexp_test < test.sexp
+  WorkingDirectory:   lib_test
+
+Test conv
+  Run$:               flag(tests)
+  Command:            $conv_test
+  WorkingDirectory:   lib_test
+# OASIS_START
+# DO NOT EDIT (digest: fc4363b322c63fb8ba9b69b2ba924c08)
+# Library sexplib
+"lib": include
+"lib/type.cmx": for-pack(Sexplib)
+"lib/Type.cmx": for-pack(Sexplib)
+"lib/parser.cmx": for-pack(Sexplib)
+"lib/Parser.cmx": for-pack(Sexplib)
+"lib/lexer.cmx": for-pack(Sexplib)
+"lib/Lexer.cmx": for-pack(Sexplib)
+"lib/pre_sexp.cmx": for-pack(Sexplib)
+"lib/Pre_sexp.cmx": for-pack(Sexplib)
+"lib/sexp_intf.cmx": for-pack(Sexplib)
+"lib/Sexp_intf.cmx": for-pack(Sexplib)
+"lib/sexp.cmx": for-pack(Sexplib)
+"lib/Sexp.cmx": for-pack(Sexplib)
+"lib/path.cmx": for-pack(Sexplib)
+"lib/Path.cmx": for-pack(Sexplib)
+"lib/conv.cmx": for-pack(Sexplib)
+"lib/Conv.cmx": for-pack(Sexplib)
+"lib/conv_error.cmx": for-pack(Sexplib)
+"lib/Conv_error.cmx": for-pack(Sexplib)
+"lib/exn_magic.cmx": for-pack(Sexplib)
+"lib/Exn_magic.cmx": for-pack(Sexplib)
+"lib/std.cmx": for-pack(Sexplib)
+"lib/Std.cmx": for-pack(Sexplib)
+<lib/*.ml{,i}>: pkg_unix
+<lib/*.ml{,i}>: pkg_num
+<lib/*.ml{,i}>: pkg_bigarray
+# Library pa_sexp_conv
+"syntax": include
+<syntax/*.ml{,i}>: pkg_type-conv
+<syntax/*.ml{,i}>: pkg_camlp4.quotations
+<syntax/*.ml{,i}>: pkg_camlp4.extend
+# Executable conv_test
+"lib_test/conv_test.byte": use_pa_sexp_conv
+"lib_test/conv_test.byte": use_sexplib
+"lib_test/conv_test.byte": pkg_unix
+"lib_test/conv_test.byte": pkg_type-conv
+"lib_test/conv_test.byte": pkg_num
+"lib_test/conv_test.byte": pkg_camlp4.quotations
+"lib_test/conv_test.byte": pkg_camlp4.extend
+"lib_test/conv_test.byte": pkg_bigarray
+<lib_test/*.ml{,i}>: use_pa_sexp_conv
+<lib_test/*.ml{,i}>: pkg_type-conv
+<lib_test/*.ml{,i}>: pkg_camlp4.quotations
+<lib_test/*.ml{,i}>: pkg_camlp4.extend
+# Library sexplib_top
+"top": include
+# Executable sexp_test
+"lib_test/sexp_test.byte": use_sexplib
+"lib_test/sexp_test.byte": pkg_unix
+"lib_test/sexp_test.byte": pkg_num
+"lib_test/sexp_test.byte": pkg_bigarray
+<lib_test/*.ml{,i}>: use_sexplib
+<lib_test/*.ml{,i}>: pkg_unix
+<lib_test/*.ml{,i}>: pkg_num
+<lib_test/*.ml{,i}>: pkg_bigarray
+# OASIS_STOP
+<syntax/pa_sexp_conv.ml>: syntax_camlp4o
+<lib/pre_sexp.ml>:pp(cpp -traditional -undef)
+
+"lib_test/conv_test.ml": syntax_camlp4o, pkg_type-conv.syntax
+# Remove this line, once BuildDepends: sexplib... will be taken
+# into account
+"lib_test/conv_test.byte": use_sexplib, pkg_unix, pkg_num, pkg_bigarray
+#!/bin/sh
+
+# OASIS_START
+# DO NOT EDIT (digest: ed33e59fe00e48bc31edf413bbc8b8d6)
+set -e
+
+ocaml setup.ml -configure $*
+# OASIS_STOP
+NAME        := README
+HEVEAFLAGS  := -w 78 -fix -exec ~/bin/xxdate.exe custom.hva 
+
+all:	text pdf
+
+$(NAME).tex:
+	touch $@
+
+-include HeveaMakefile
+USEPDFLATEX = true
+DOC = README
+
+LaTeXDocument($(DOC), $(DOC))
+
+doc: $(DOC).pdf
+
+.DEFAULT: $(DOC).pdf
+\documentclass[a4paper]{article}
+
+\usepackage{hevea}
+
+%BEGIN LATEX
+\usepackage{natbib}
+%END LATEX
+
+\newcommand{\mail}{\mailto{opensource@janestreet.com}}
+\newcommand{\homeurl}{http://www.janestreet.com}
+\newcommand{\athome}[2]{\ahref{\homeurl/#1}{#2}}
+\newcommand{\www}{\athome{}{Markus Mottl}}
+
+\newcommand{\ocaml}{\ahref{http://www.ocaml.org}{OCaml}}
+
+\newcommand{\myhref}[1]{\ahref{#1}{#1}}
+\newcommand{\ocsrc}[2]{\athome{ocaml/#1}{#2}}
+\newcommand{\myocsrc}[1]{\athome{ocaml/#1}{#1}}
+
+\newcommand{\janeshort}
+  {\ahref{http://www.janestreet.com}{Jane Street Holding, LLC}}
+
+\newcommand{\trow}[2]{\quad #1 \quad&\quad #2 \quad\\}
+\newcommand{\trowl}[2]{\trow{#1}{#2}\hline}
+
+%BEGIN LATEX
+\newcommand{\theyear}{\number\year}
+%END LATEX
+
+\title{README: library ``Sexplib''}
+\author{
+  Copyright \quad (C) \quad \theyear \quad \janeshort \quad\\
+  Author: Markus Mottl
+}
+\date{New York, 2010-03-31}
+
+% DOCUMENT
+\begin{document}
+\maketitle
+\section{Directory contents}
+\begin{center}
+\begin{tabular}{|c|c|}
+\hline
+\trowl{CHANGES}{History of code changes}
+\trowl{COPYRIGHT}{Notes on copyright}
+\trow{INSTALL}{Short notes on compiling and}
+\trowl{}{installing the library}
+\trowl{LICENSE}{``GNU LESSER GENERAL PUBLIC LICENSE''}
+\trowl{LICENSE.Tywith}{License of Tywith, from which Sexplib is derived}
+\trowl{Makefile}{Top Makefile}
+\trowl{OCamlMakefile}{Generic Makefile for OCaml-projects}
+\trowl{OMakefile}{Ignore this file}
+\trowl{README.txt}{This file}
+\trowl{lib/}{OCaml-library for S-expression conversions}
+\trowl{lib\_test/}{Test applications for the Sexplib-library}
+\end{tabular}
+\end{center}
+
+\section{What is ``Sexplib''?}
+
+This library contains functionality for parsing and pretty-printing
+S-expressions.  In addition to that it contains a preprocessing module for
+Camlp4, which can be used to automatically generate code from type definitions
+for efficiently converting OCaml-values to S-expressions and vice versa.
+In combination with the parsing and pretty-printing functionality this frees
+users from having to write their own I/O-routines for datastructures they
+define.  Possible errors during automatic conversions from S-expressions
+to OCaml-values are reported in human-readable ways with exact location
+information.  Another module in this library allows you to extract and
+replace sub-expressions in S-expressions.
+
+\section{How can you use it?}
+
+Make sure you have installed the \verb=type-conv= package on your system,
+too.  It should be obtainable at the same site as \verb=sexplib=.\\
+\\
+The API (.mli-files) in the \verb=sexplib= library directory is
+fully documented.  Module \verb=Sexp= contains all I/O-functions for
+S-expressions, module \verb=Conv= helper functions for converting
+OCaml-values of standard types to S-expressions.  Module \verb=Path=
+supports sub-expression extraction and substitution.\\
+\\
+Module \verb=pa_sexp_conv.ml= contains the extensions for the
+Camlp4-preprocessor.  It adds the new construct \verb=with sexp=
+(and \verb=with sexp_of= and \verb=with of_sexp=, which are implied by
+the first).  When using this construct right after a type definition,
+function definitions will be generated automatically, which perform
+S-expression conversions.\\
+\\
+E.g.\ given the following type definition:
+
+\begin{verbatim}
+  type t = A | B
+  with sexp
+\end{verbatim}
+
+The above will generate the functions \verb=sexp_of_t= and
+\verb=t_of_sexp=.  The preprocessor also supports automatic addition
+of conversion functions to signatures.  Just add \verb=with sexp= to
+the type in a signature, and the appropriate function signatures will
+be generated.\\
+\\
+See the file \verb=lib_test/conv_test.ml= for example usage.  It also
+demonstrates how to extract and substitute sub-expressions.
+
+\subsection{Compiling and linking}
+
+To compile a file you will have to add a preprocessing flag to the
+compiler invocation, e.g. for foo.ml:
+
+\begin{verbatim}
+  ocamlc -pp "camlp4o -I {path to type-conv} \
+    -I {path to sexplib} pa_type_conv.cmo pa_sexp_conv.cmo" \
+    -I {path to sexplib} foo.ml
+\end{verbatim}
+
+If you are using OCamlMakefile, just put the following line at the
+top of the file, assuming you have installed both \verb=type-conv= and
+\verb=sexplib= with ocamlfind.  The comment must start at the beginning of
+the line, and you must not break lines (here broken for readability only):
+
+\begin{verbatim}
+  (*pp camlp4o -I `ocamlfind query type-conv` \
+    -I `ocamlfind query sexplib` \
+    pa_type_conv.cmo pa_sexp_conv.cmo *)
+\end{verbatim}
+
+Don't forget to place the macro \verb=TYPE_CONV_PATH=, which takes a
+string argument, at the top of the file to be preprocessed (see example
+\verb=conv_test.ml=).  It is supposed to set the module path to the given
+module file.  This is necessary, because modules may get packed at a later
+stage, and error messages generated by Sexplib will refer to this location
+to help pinpointing the associated type.\\
+\\
+In the linking stage you will only have to link with \verb=sexplib=.
+E.g.\ when using OCamlMakefile just add it to the \verb=PACKS=-variable.
+
+\section{Syntax Specification of S-expressions}
+
+\subsection{Lexical conventions of S-expression}
+
+Whitespace, which consists of space, newline, carriage return, horizontal
+tab and form feed, is ignored unless within an OCaml-string, where it
+is treated according to OCaml-conventions.  The semicolon introduces
+comments.  Comments are ignored, and range up to the next newline
+character.  The left parenthesis opens a new list, the right parenthesis
+closes it again.  Lists can be empty.  The double quote denotes the
+beginning and end of a string following the lexical conventions of OCaml
+(see OCaml-manual for details).  All characters other than double quotes,
+left- and right parentheses, and whitespace are considered part of a
+contiguous string.
+
+\subsection{Grammar of S-expressions}
+
+S-expressions are either strings (= atoms) or lists. The lists can
+recursively contain further S-expressions or be empty, and must be
+balanced, i.e.\ parentheses must match.
+
+\subsection{Examples}
+
+{\samepage
+\begin{verbatim}
+  this_is_an_atom_123'&^%!  ; this is a comment
+  "another atom in an OCaml-string \"string in a string\" \123"
+
+  ; empty list follows below
+  ()
+
+  ; a more complex example
+  (
+    (
+      list in a list  ; comment within a list
+      (list in a list in a list)
+      42 is the answer to all questions
+    )
+  )
+\end{verbatim}
+}
+
+\subsection{Conversion of basic OCaml-values}
+
+Basic OCaml-values like the unit-value, integers (in all representations),
+floats, strings, and booleans are represented in S-exp syntax in the
+same way as in OCaml.  Strings may also appear without quotes if this
+does not clash with the lexical conventions for S-expressions.
+
+\subsection{Conversion of OCaml-tuples}
+
+OCaml-tuples are simple lists of values in the same order as in the tuple.
+E.g.:
+
+\begin{verbatim}
+  (3.14, "foo", "bar bla", 27) <===> (3.14 foo "bar bla" 27)
+\end{verbatim}
+
+\subsection{Conversion of OCaml-records}
+
+OCaml-records are represented as lists of pairs in S-expression syntax.
+Each pair consists of the name of the record field (first element),
+and its value (second element).  E.g.:
+
+\begin{verbatim}
+  {
+    foo = 3;
+    bar = "some string";
+  }
+
+  <===>
+
+  (
+    (foo 3)
+    (bar "some string")
+  )
+\end{verbatim}
+
+Type specifications of records allow the use of a special type
+\verb=sexp_option= which indicates that a record field should be optional.
+E.g.:
+
+\begin{verbatim}
+  type t =
+    {
+      x : int option;
+      y : int sexp_option;
+    }
+\end{verbatim}
+
+The type \verb=sexp_option= is equivalent to ordinary options, but is
+treated specially by the code generator.  The above would lead to the
+following equivalences of values and S-expressions:
+
+\begin{verbatim}
+  {
+    x = Some 1;
+    y = Some 2;
+  }
+
+  <===>
+
+  (
+    (x (some 1))
+    (y 2)
+  )
+\end{verbatim}
+
+\noindent And:
+
+{\samepage
+\begin{verbatim}
+  {
+    x = None;
+    y = None;
+  }
+
+  <===>
+
+  (
+    (x none)
+  )
+\end{verbatim}
+}
+
+Note how \verb=sexp_option= allows you to leave away record fields
+that should default to \verb=None=.  It is also unnecessary (and
+actually wrong) now to write down such a value as an option, i.e.\
+the \verb=some=-tag must be dropped if the field should be defined.\\
+\\
+The types \verb=sexp_list=, \verb=sexp_array=, and \verb=sexp_bool= can be
+used in ways similar to the type \verb=sexp_option=.  They assume the empty
+list, empty array, and false value respectively as default values.
+
+\subsection{Conversion of sum types}
+
+Constant constructors in sum types are represented as strings.
+Constructors with arguments are represented as lists, the first element
+being the constructor name, the rest being its arguments.  Constructors
+may also be started in lowercase in S-expressions, but will always be
+converted to uppercase when converting from OCaml-values.\\
+\\
+{\samepage
+\noindent For example:
+
+\begin{verbatim}
+  type t = A | B of int * float * t with sexp
+
+  B (42, 3.14, B (-1, 2.72, A)) <===> (B 42 3.14 (B -1 2.72 A))
+\end{verbatim}
+
+\noindent The above example also demonstrates recursion in datastructures.
+}
+
+\subsection{Conversion of variant types}
+
+The conversion of polymorphic variants is almost the same as with
+sum types.  The notable difference is that variant constructors must
+always start with an either lower- or uppercase character, matching
+the way it was specified in the type definition.  This is because OCaml
+also distinguishes between upper- and lowercase variant constructors.
+Note that type specifications containing unions of variant types are
+also supported by the S-expression converter.
+
+\subsection{Conversion of OCaml-lists and arrays}
+
+OCaml-lists and arrays are straightforwardly represented as S-expression
+lists.
+
+\subsection{Conversion of option types}
+
+The option type is converted like ordinary polymorphic sum types, i.e.:
+
+\begin{verbatim}
+  None        <===>  none
+  Some value  <===>  (some value)
+\end{verbatim}
+
+There is a deprecated version of the syntax in which values of option
+type are represented as lists in S-expressions:
+
+\begin{verbatim}
+  None        <===>  ()
+  Some value  <===>  (value)
+\end{verbatim}
+
+Reading of the old-style S-expression syntax for option values is only
+supported if the reference \verb=Conv.read_old_option_format= is set to
+\verb=true= (currently the default, which may change soon).  A conversion
+exception is raised otherwise.  The old format will be written only if
+\verb=Conv.write_old_option_format= is true (also currently the default).
+Reading of the new format is always supported.
+
+\subsection{Conversion of polymorphic values}
+
+There is nothing special about polymorphic values as long as there are
+conversion functions for the type parameters.  E.g.:
+
+\begin{verbatim}
+  type 'a t = A | B of 'a with sexp
+  type foo = int t with sexp
+\end{verbatim}
+
+In the above case the conversion functions will behave as if \verb=foo=
+had been defined as a monomorphic version of \verb=t= with \verb='a=
+replaced by \verb=int= on the right hand side.\\
+\\
+If a datastructure is indeed polymorphic, and you want to convert it,
+you will have to supply the conversion functions for the type parameters
+at runtime.  E.g.\ in the above example, if you wanted to convert a value
+of type \verb='a t=, you would have to write something like this:
+
+\begin{verbatim}
+  sexp_of_t sexp_of_a v
+\end{verbatim}
+
+\noindent where \verb=sexp_of_a=, which may also be named differently in
+this particular case, is a function that converts values of type \verb='a=
+to an S-expression.  Types with more than one parameter require passing
+conversion functions for those parameters in the order of their appearance
+on the left hand side of the type definition.
+
+\subsection{Conversion of abstract datatypes}
+
+Of course, if you want to convert an abstract datatype to an S-expression,
+you will have to roll your own conversion function, which should produce
+values of type \verb=Sexp.t= directly.  If, however, you want to make
+use of your abstract type within definitions of other types, make sure
+that you call your conversion function appropriately: it should be in the
+same scope as the typename, and must be named \verb=sexp_of_{typename}=.
+
+\subsection{Conversion of hashtables}
+
+Hashtables, which are abstract values in OCaml, are represented as
+association lists, i.e.\ lists of key-value pairs, e.g.:
+
+\begin{verbatim}
+  ((foo 42) (bar 3))
+\end{verbatim}
+
+Reading in the above S-expression as hashtable mapping strings to
+integers (\verb=(string, int) Hashtbl.t=) will map \verb="foo"= to $42$
+and \verb="bar"= to $3$.\\
+\\
+Note that the order of elements in the list may matter, because
+duplicates are kept: bindings will be inserted into the hashtable in
+order of appearence.  Therefore, the last binding of a key will be the
+``visible'' one, the others are ``hidden''.  See the OCaml-documentation
+on hashtables for details.\\
+\\
+Note, too, that polymorphic equality may not hold between conversions.
+You will have to use a function implementing logical equality for that
+purpose.
+
+\subsection{Conversion of opaque values}
+
+Opaque values are ones for which we do not want to perform conversions.
+This may be, because we do not have S-expression converters for them,
+or because we do not want to apply them in a particular type context,
+e.g.\ if the resulting S-expression should be printed out but without
+superfluous information.  To prevent the preprocessor from generating
+calls to converters, simply apply the qualifier \verb=sexp_opaque=
+as if it were a type constructor, e.g.:
+
+\begin{verbatim}
+  type foo = int * stuff sexp_opaque with sexp
+\end{verbatim}
+
+Thus, there is no need to specify converters for type \verb=stuff=,
+and if there are any, they will not be used in this particular context.
+Needless to say, it is not possible to convert such an S-expression back
+to the original value.  Here is an example conversion:
+
+\begin{verbatim}
+  (42, some_stuff) ===>  (42, <opaque>)
+\end{verbatim}
+
+\subsection{Conversion of exceptions}
+
+S-expression converters for exceptions can be automatically registered
+using the \verb=with sexp= macro, e.g.:
+
+\begin{verbatim}
+  module M = struct
+    exception Foo of int with sexp
+  end
+\end{verbatim}
+
+Such exceptions will be translated in a similar way as sum types, but
+their constructor will be prefixed with the fully qualified module path
+(here: \verb=M.Foo=) so as to be able to discriminate between them
+without problems.\\
+
+The user can then easily convert an exception matching the above
+one to an S-expression using \verb=Sexplib.Conv.sexp_of_exn=.
+User-defined conversion functions can be registered, too, by calling
+\verb=Sexplib.Conv.add_exn_converter=.  This should make it very
+convenient for users to catch arbitrary exceptions escaping their program
+and pretty-printing them, including all arguments, as S-expressions.
+The library already contains mappings for all known exceptions that can
+escape functions in the OCaml standard library.
+
+\section{I/O and type conversions}
+
+There are multiple ways of performing I/O with S-expressions.  If exact
+error locations are required when type conversions fail, S-expressions need
+to be parsed with location annotations.  In most cases users may want to use
+functions like e.g.\ \verb=load_sexp_conv= or \verb=load_sexp_conv_exn=, which
+load S-expressions from files and convert them.  Only when conversions fail,
+the file will be reparsed with annotations, which is slower, and type errors
+will be reported accurately with file, line number, column, and file position.
+
+\section{Contact information}
+
+\noindent In the case of bugs, feature requests and similar, you can
+contact us here:\\
+
+\hspace{2ex}\mail\\
+
+\noindent Up-to-date information concerning this library should be
+available here:\\
+
+\hspace{2ex}\homeurl/ocaml\\
+
+Enjoy!!\\
+
+\end{document}
+% INPUT STYLE
+\input{article.hva}
+
+% FANCY SECTION HEADERS WITH NICE COLOURS
+\def\@color{194}
+\input{fancysection.hva}
+
+% FOREGROUND AND BACKGROUND COLOURS
+\renewcommand{\@bodyargs}{TEXT=black BGCOLOR=white}
+% hevea  : hevea.sty
+% This is a very basic style file for latex document to be processed
+% with hevea. It contains definitions of LaTeX environment which are
+% processed in a special way by the translator. 
+%  Mostly :
+%     - latexonly, not processed by hevea, processed by latex.
+%     - htmlonly , the reverse.
+%     - rawhtml,  to include raw HTML in hevea output.
+%     - toimage, to send text to the image file.
+% The package also provides hevea logos, html related commands (ahref
+% etc.), void cutting and image commands.
+\NeedsTeXFormat{LaTeX2e}
+\ProvidesPackage{hevea}[2002/01/11]
+\RequirePackage{comment}
+\newif\ifhevea\heveafalse
+\@ifundefined{ifimagen}{\newif\ifimagen\imagenfalse}
+\makeatletter%
+\newcommand{\heveasmup}[2]{%
+\raise #1\hbox{$\m@th$%
+  \csname S@\f@size\endcsname
+  \fontsize\sf@size 0%
+  \math@fontsfalse\selectfont
+#2%
+}}%
+\DeclareRobustCommand{\hevea}{H\kern-.15em\heveasmup{.2ex}{E}\kern-.15emV\kern-.15em\heveasmup{.2ex}{E}\kern-.15emA}%
+\DeclareRobustCommand{\hacha}{H\kern-.15em\heveasmup{.2ex}{A}\kern-.15emC\kern-.1em\heveasmup{.2ex}{H}\kern-.15emA}%
+\DeclareRobustCommand{\html}{\protect\heveasmup{0.ex}{HTML}}
+%%%%%%%%% Hyperlinks hevea style
+\newcommand{\ahref}[2]{{#2}}
+\newcommand{\ahrefloc}[2]{{#2}}
+\newcommand{\aname}[2]{{#2}}
+\newcommand{\ahrefurl}[1]{\texttt{#1}}
+\newcommand{\footahref}[2]{#2\footnote{\texttt{#1}}}
+\newcommand{\mailto}[1]{\texttt{#1}}
+\newcommand{\imgsrc}[2][]{}
+\newcommand{\home}[1]{\protect\raisebox{-.75ex}{\char126}#1}
+\AtBeginDocument
+{\@ifundefined{url}
+{%url package is not loaded
+\let\url\ahref\let\oneurl\ahrefurl\let\footurl\footahref}
+{}}
+%% Void cutting instructions
+\newcounter{cuttingdepth}
+\newcommand{\tocnumber}{}
+\newcommand{\notocnumber}{}
+\newcommand{\cuttingunit}{}
+\newcommand{\cutdef}[2][]{}
+\newcommand{\cuthere}[2]{}
+\newcommand{\cutend}{}
+\newcommand{\htmlhead}[1]{}
+\newcommand{\htmlfoot}[1]{}
+\newcommand{\htmlprefix}[1]{}
+\newenvironment{cutflow}[1]{}{}
+\newcommand{\cutname}[1]{}
+\newcommand{\toplinks}[3]{}
+%%%% Html only
+\excludecomment{rawhtml}
+\newcommand{\rawhtmlinput}[1]{}
+\excludecomment{htmlonly}
+%%%% Latex only
+\newenvironment{latexonly}{}{}
+\newenvironment{verblatex}{}{}
+%%%% Image file stuff
+\def\toimage{\endgroup}
+\def\endtoimage{\begingroup\def\@currenvir{toimage}}
+\def\verbimage{\endgroup}
+\def\endverbimage{\begingroup\def\@currenvir{verbimage}}
+\newcommand{\imageflush}[1][]{}
+%%% Bgcolor definition
+\newsavebox{\@bgcolorbin}
+\newenvironment{bgcolor}[2][]
+  {\newcommand{\@mycolor}{#2}\begin{lrbox}{\@bgcolorbin}\vbox\bgroup}
+  {\egroup\end{lrbox}%
+   \begin{flushleft}%
+   \colorbox{\@mycolor}{\usebox{\@bgcolorbin}}%
+   \end{flushleft}}
+%%% Postlude
+\makeatother
+# OASIS_START
+# DO NOT EDIT (digest: c6a0876123fd610ef2e8594e61105626)
+version = "7.0.4"
+description = "automated S-expression conversion"
+requires = "unix bigarray num"
+archive(byte) = "sexplib.cma"
+archive(native) = "sexplib.cmxa"
+exists_if = "sexplib.cma"
+package "syntax" (
+ version = "7.0.4"
+ description = "Syntax extension for Sexplib"
+ requires = "type-conv sexplib"
+ archive(syntax,preprocessor) = "pa_sexp_conv.cma"
+ archive(syntax,toploop) = "pa_sexp_conv.cma"
+ exists_if = "pa_sexp_conv.cma"
+)
+
+package "top" (
+ version = "7.0.4"
+ description = "Toplevel printers for S-expressions"
+ requires = "sexplib"
+ archive(byte) = "sexplib_top.cma"
+ archive(native) = "sexplib_top.cmxa"
+ exists_if = "sexplib_top.cma"
+)
+# OASIS_STOP
+(******************************************************************************
+ *                             Sexplib                                        *
+ *                                                                            *
+ * Copyright (C) 2005- Jane Street Holding, LLC                               *
+ *    Contact: opensource@janestreet.com                                      *
+ *    WWW: http://www.janestreet.com/ocaml                                    *
+ *    Author: Markus Mottl                                                    *
+ *                                                                            *
+ * This library is free software; you can redistribute it and/or              *
+ * modify it under the terms of the GNU Lesser General Public                 *
+ * License as published by the Free Software Foundation; either               *
+ * version 2 of the License, or (at your option) any later version.           *
+ *                                                                            *
+ * This library is distributed in the hope that it will be useful,            *
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of             *
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU          *
+ * Lesser General Public License for more details.                            *
+ *                                                                            *
+ * You should have received a copy of the GNU Lesser General Public           *
+ * License along with this library; if not, write to the Free Software        *
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  *
+ *                                                                            *
+ ******************************************************************************)
+
+(* Conv: Utility Module for S-expression Conversions *)
+
+open Printf
+open Bigarray
+open Sexp
+
+type sexp_bool = bool
+type 'a sexp_option = 'a option
+type 'a sexp_list = 'a list
+type 'a sexp_array = 'a array
+type 'a sexp_opaque = 'a
+
+type bigstring = Sexp.bigstring
+type float32_vec = (float, float32_elt, fortran_layout) Array1.t
+type float64_vec = (float, float64_elt, fortran_layout) Array1.t
+type vec = float64_vec